#include <bits/stdc++.h>
using namespace std;
long long a[300005];
long long b[300005];
long long poslednji[300005];
long long pre[300005];
int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n,q;
    cin>>n>>q;
    for(int i=0; i<n; i++)
    {
        cin>>a[i]>>b[i];
        if(i==0)
        {
            poslednji[i]=a[i]+b[i]-1;
            pre[0]=0;
        }
        else
        {
            if(poslednji[i-1]>=a[i])
                poslednji[i]=poslednji[i-1]+b[i];
            else poslednji[i]=a[i]+b[i]-1;
            if(poslednji[i]>1000000000000000000)
                poslednji[i]=1000000000000000000;
            if(poslednji[i-1]>=a[i]-1)
                pre[i]=pre[i-1]+a[i]-a[i-1];
            else pre[i]=pre[i-1]+poslednji[i-1]-a[i-1]+1;
        }
    }
    a[n]=1000000000000000005;
    long long x;
    int s=0;
    while(q--)
    {
        cin>>x;
        if(x<a[0])
            cout<<0<<endl;
        else
        {
            while(x>=a[s+1])
                s++;
            if(a[n-1]<x)
                s=n-1;
            if(a[s]==x)
                cout<<pre[s]+1<<endl;
            else
            {
                if(poslednji[s]>=x)
                    cout<<pre[s]+x-a[s]+1<<endl;
                else cout<<pre[s]+poslednji[s]-a[s]+1<<endl;
            }
        }
    }
    return 0;
}